package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.StringUtils;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.OwLeavingMessage;
import com.zksy.system.basicData.domain.dto.OwLeavingMessageDTO;
import com.zksy.system.basicData.service.CaptchaService;
import com.zksy.system.basicData.service.OwLeavingMessageService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.aspectj.weaver.loadtime.Aj;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * 官网留言Controller
 *
 * @author sy
 * @date 2024-06-27
 */
@RestController
@RequestMapping("/owLeavingMessage")
@Api(tags = "官网留言", description = "官网留言desc")
public class OwLeavingMessageController extends BaseController {

    @Autowired
    private OwLeavingMessageService service;
    @Autowired
    private CaptchaService captchaService;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "官网留言搜索getById")
    public OwLeavingMessage getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "官网留言分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "官网留言查询所有")
    public List<OwLeavingMessage> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增官网留言
     */
    @PostMapping("/save")
    @ApiOperation(value = "官网留言新增")
//    @Log(title = "新增官网留言", businessType = BusinessType.INSERT)
    public AjaxResult save(@RequestBody OwLeavingMessageDTO dto) {
//        if (dto.getNeedAuthCode()) {
        String msg = captchaService.checkImageCode(dto.getImageKey(), dto.getImageCode());
        if (StringUtils.isNotBlank(msg)) {
            return AjaxResult.error(999,msg);
        }
//        }
        OwLeavingMessage owLeavingMessage = new OwLeavingMessage();
        BeanUtils.copyProperties(dto, owLeavingMessage);
        owLeavingMessage.setCreateTime(new Date());
        Boolean flag = service.save(owLeavingMessage);
        if (flag) {
            return AjaxResult.success("留言成功");
        } else {
            return AjaxResult.success("留言失败");
        }
    }

    /**
     * 修改官网留言
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "官网留言修改")
    @Log(title = "修改官网留言", businessType = BusinessType.UPDATE)
    public AjaxResult updateById(@RequestBody OwLeavingMessage owLeavingMessage) {
        owLeavingMessage.setUpdateTime(new Date());
        return AjaxResult.success(service.updateById(owLeavingMessage));
    }

    /**
     * 导入官网留言
     */
    @ApiOperation("官网留言导入")
    @Log(title = "官网留言", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file) {
        try {
            List<OwLeavingMessage> owLeavingMessageAll = service.list();
            List<OwLeavingMessage> list = ExcelUtils.readMultipartFile(file, OwLeavingMessage.class, OwLeavingMessage.class.getDeclaredFields().length - 2);
            if (owLeavingMessageAll != null && owLeavingMessageAll.size() > 0) {
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if (list.size() > 0) {
                service.saveBatch(list);
                return success("导入成功，共计：" + list.size() + "条");
            } else {
                return AjaxResult.error("无数据");
            }
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("官网留言导出")
    @Log(title = "官网留言", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson) {
        try {
            List<OwLeavingMessage> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response, "官网留言", wrapperList, OwLeavingMessage.class);
            return AjaxResult.success("导出数据成功");
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "官网留言", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除官网留言", notes = "删除官网留言")
    public AjaxResult delete(@RequestBody List<String> ids) {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll() {
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response, "官网留言模板");
    }

    @PostMapping("/generateVoucher")
    public void generateVoucher(HttpServletResponse response, String name, Long id) throws Exception {
        service.generateVoucher(response, name, id);
    }
}

